package org.bdware.client;

import com.google.gson.JsonObject;
import org.zz.gmhelper.SM2KeyPair;

public class AutoRegister {
    public static void main(String[] args) {
        String keyPairStr = "{\"privateKey\":\"347caf3393482440cf5a79995b2c83f567644dfa9b4804755bd093141542db96\",\"publicKey\":\"04f5c7cc4b202047da7aff4b93e66204d8e04d0e26435e792afcfb8b4bf918b9b4ec8550e669fb1581203fcd7187ea993391d6c3ee6e348ee17febee3bdad783c3\"}";
        //        "{\"privateKey\":\"589d94ee5688358a1c5c18430dd9c75097ddddebf769f139da36a807911d20f8\",\"publicKey\":\"04d1924329f72ced148f6f333fb985ccbaa31b1e3aacf10be5f43d4a4ff5ad88899a005e79e37fc06993e1d66ada8cf8b711cb36f59538bb7d3e39e70fa9360ddd\"}";
        //; "{\"privateKey\":\"b1f6223a49b9e0943016505e932a17ea0bfe357f3b23cae28f847db9566d30cf\",\"publicKey\":\"0469344c29715c32f0f45765f9446c6208eb1f9ce2c2b765a1c6a7f50e0f8fdb904be2acbaa41898e25144aa5740f5c1dfccdd8bc7fff193dee94269853b1d476b\"}";
        SM2KeyPair keyPair = SM2KeyPair.fromJson(keyPairStr);
        String[] ips = new String[]{"10.10.133.38", "10.10.133.55", "10.10.133.56", "10.10.133.5"};
        for (String ip : ips) {
            initialize(ip, 21030, keyPair);
        }
    }

    public static void initialize(String ip, int port, SM2KeyPair keyPair) {
        String local = "ws://" + ip + ":" + port + "/SCIDE/SCExecutor";
        System.out.println("config:" + ip + ":" + port);

        SmartContractClient testClient =
                new SmartContractClient(local, keyPair) {
                    public void onListContractProcess(JsonObject obj) {
                        super.onListContractProcess(obj);
                    }

                    public void onLogin(JsonObject obj) {
                        this.setName("Node_" + port);
                        this.setBDLedger("127.0.0.1:18030");
                        this.setMasterAddress(ip + ":" + (port + 1));
                        String apply =
                                "{\"action\":\"applyNodeRole\",\"role\":\"_ROLE_\",\"pubKey\":\"04d1924329f72ced148f6f333fb985ccbaa31b1e3aacf10be5f43d4a4ff5ad88899a005e79e37fc06993e1d66ada8cf8b711cb36f59538bb7d3e39e70fa9360ddd\"}";
                        this.sendMsg(apply.replaceAll("_ROLE_", "ContractProvider"));
                        this.sendMsg(apply.replaceAll("_ROLE_", "ContractUser"));
                        this.sendMsg(apply.replaceAll("_ROLE_", "ContractInstanceManager"));
                        String auth =
                                "{\"action\":\"authNodeRole\",\"pubKey\":\"04f5c7cc4b202047da7aff4b93e66204d8e04d0e26435e792afcfb8b4bf918b9b4ec8550e669fb1581203fcd7187ea993391d6c3ee6e348ee17febee3bdad783c3\",\"isAccept\":true}";
                        this.sendMsg(auth);
                        this.setClusterAddress("ws://10.10.133.38:18002");
                        this.listContractProcess();
                    }
                };
        testClient.waitForConnect();
        testClient.login();
        try {
            Thread.sleep(10000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
}
