package org.bdware.client;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

public class TimeoutUtil {
    static ExecutorService executor = Executors.newCachedThreadPool();

    public static Callable<Object> wrapFunction(Object callback, Object arg) {
        Callable<Object> callable = new Callable<Object>() {
            @Override
            public Object call() throws Exception {
                Class clz = Class.forName("org.bdware.sc.boundry.JavaScriptEntry");
                Class scriptFunction = Class.forName("wrp.jdk.nashorn.internal.runtime.ScriptFunction");
                Class sco = Class.forName("wrp.jdk.nashorn.api.scripting.ScriptObjectMirror");
                Field field = sco.getDeclaredField("sobj");
                field.setAccessible(true);
                Method method = clz.getDeclaredMethod("executeFunction", scriptFunction, Object.class);
                return method.invoke(null, field.get(callback), arg);
            }
        };
        return callable;
    }

    public static <T> T runWithTimeout(Callable<T> callable, int timeout) {
        T ret;
        try {
            ret = executor.submit(callable).get(timeout, TimeUnit.MILLISECONDS);
        } catch (Exception e) {
            e.printStackTrace();
            ret = null;
        }
        return ret;
    }
}
